package farmacie_senza_interfacce;

import java.util.*;

import farmacie.MedicinaleAlternativo.Tipologia;

public class Farmacia {
	
	public static final int NUM_CONFEZIONI = 5;
	
	private static int progressivo = 0;
	
	private int codice;
	private String indirizzo;
	private List<Medicinale> prontuario;
	private Map<Medicinale,DatiFarmaco> disponibilita;
	
	public Farmacia(){
		this("",new ArrayList<Medicinale>(),new HashMap<Medicinale,DatiFarmaco>());
	}
	
	public Farmacia(String i, List<Medicinale> p, Map<Medicinale,DatiFarmaco> d){
		codice = ++progressivo;
		indirizzo = i;
		prontuario = p;
		disponibilita = d;
	}
	
	// metodo 1)
	public boolean trovaMedicinale(String codice){
		int i;
		for(i=0; i<prontuario.size() && !(prontuario.get(i).getCodice().equals(codice)); i++);
		if(i<prontuario.size())
			return true;
		else
			return false;
	}
	
	// metodo 2)
	public double percentualeOmeopaticiPerFormato(Medicinale.Formato f){
		int numFarmaci=0;
		for(int i=0; i<prontuario.size();i++)
			if(prontuario.get(i) instanceof MedicinaleAlternativo && 
					((MedicinaleAlternativo)(prontuario.get(i))).isOmeopatico() &&
					prontuario.get(i).getFormato()==f)
				numFarmaci++;
		return (double)numFarmaci/prontuario.size()*100;
	}
	
	// metodo 3)
	public boolean aggiungiMedicinale(Medicinale m, double p, int n){
		boolean presente = trovaMedicinale(m.getCodice());
		if(!presente){
			prontuario.add(m);
			disponibilita.put(m,new DatiFarmaco(p,n));
		}
		else
			disponibilita.put(m,new DatiFarmaco(p,n+disponibilita.get(m).getNumConfezioni()));
		return presente;
	}
	
	// metodo 4)
	public Set<Medicinale> riordino(){
		Set<Medicinale> daOrdinare = new HashSet<Medicinale>();
		Iterator<Medicinale> i = disponibilita.keySet().iterator();
		while(i.hasNext()){
			Medicinale m = i.next();
			if (disponibilita.get(m).getNumConfezioni()<NUM_CONFEZIONI)
				daOrdinare.add(m);
		}
		return daOrdinare;
	}
	

}
