package farmacie_senza_interfacce;

import java.util.*;

public abstract class Medicinale{
	
	public static enum Formato {COMPRESSE, SCIROPPO, POMATA}
	private static int progressivo = 0;
	
	protected String codice;
	protected String principioAttivo;
	protected Set<String> eccipienti;
	protected Formato formato;
	protected String casaFarmaceutica;
	
	public Medicinale(){
		this("",new HashSet<String>(),null,"");
	}
	
	public Medicinale(String p, Set<String> e, Formato f, String c){
		codice = ++progressivo+"_"+c.substring(0,3)+c.substring(3).length();
		principioAttivo = p;
		eccipienti = e;
		formato = f;
		casaFarmaceutica = c;
	}
	
	public String getCodice(){
		return codice;
	}
	
	public Formato getFormato(){
		return formato;
	}
	
}
